// OurImplicitFunction.cpp: OurImplicitFunction NX̃Cve[V
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "OurImplicitFunction.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

#define PI 3.14159265

//////////////////////////////////////////////////////////////////////
// \z/
//////////////////////////////////////////////////////////////////////

OurImplicitFunction::OurImplicitFunction()
{
	count = 0;
}

OurImplicitFunction::~OurImplicitFunction()
{

}

void OurImplicitFunction::EvaluateGradient(float x[], float g[])
{	
	/*
	float R = 3;
	float r = 1;

	float P[3];
	double l = sqrt(x[0]*x[0] + x[1]*x[1]);
	P[0] = x[0] - R*x[0]/l;
	P[1] = x[1] - R*x[1]/l;
	P[2] = x[2];

	l = MeshData::LENGTH(P);

	g[0] = -P[0]/l;
	g[1] = -P[1]/l;
	g[2] = -P[2]/l;

	return;
	*/


	/*
	double l = sqrt(x[0]*x[0] + x[1]*x[1] + x[2]*x[2]);
	g[0] = -x[0]/l;
	g[1] = -x[1]/l;
	g[2] = -x[2]/l;

	return;
	*/

	/*
	float g1[3];
	nabla(x, g1);
	float gg[3][3];
	doubleNabla(x, gg);
	double f = model(x);

	double d = f*f + g1[0]*g1[0] + g1[1]*g1[1] + g1[2]*g1[2];
	double d2 = pow(d, 1.5);
	double b[3];
	b[0] = gg[0][0]*g1[0] + gg[0][1]*g1[1] + gg[0][2]*g1[2];
	b[1] = gg[1][0]*g1[0] + gg[1][1]*g1[1] + gg[1][2]*g1[2];
	b[2] = gg[2][0]*g1[0] + gg[2][1]*g1[1] + gg[2][2]*g1[2];

	g[0] = (d*g1[0] - f*f*g1[0] - f*b[0])/d2;
	g[1] = (d*g1[1] - f*f*g1[1] - f*b[1])/d2;
	g[2] = (d*g1[2] - f*f*g1[2] - f*b[2])/d2;

	return;
	*/

	float p1[3], p2[3];

	p1[0] = x[0] - h; 
	p1[1] = x[1];
	p1[2] = x[2];
	
	p2[0] = x[0] + h; 
	p2[1] = x[1];
	p2[2] = x[2];

	g[0] = (EvaluateFunction(p2) - EvaluateFunction(p1))/(2.0f*h);

	p1[0] = x[0]; 
	p1[1] = x[1] - h;
	p1[2] = x[2];
	
	p2[0] = x[0]; 
	p2[1] = x[1] + h;
	p2[2] = x[2];

	g[1] = (EvaluateFunction(p2) - EvaluateFunction(p1))/(2.0f*h);

	p1[0] = x[0]; 
	p1[1] = x[1];
	p1[2] = x[2] - h;
	
	p2[0] = x[0]; 
	p2[1] = x[1];
	p2[2] = x[2] + h;

	g[2] = (EvaluateFunction(p2) - EvaluateFunction(p1))/(2.0f*h);
}

float OurImplicitFunction::EvaluateFunction(float x[])
{
	count++;

	/*
	float R = 3;
	float r = 1;

	float P[3];
	double l = sqrt(x[0]*x[0] + x[1]*x[1]);
	P[0] = x[0] - R*x[0]/l;
	P[1] = x[1] - R*x[1]/l;
	P[2] = x[2];

	return r - MeshData::LENGTH(P);
	*/
	

	/*
	float x1[3];
	x1[0] = x[0]/3;
	x1[1] = x[1]/3;
	x1[2] = x[2]/3;

	float A1[] = {4,0,-3};
	float B1[] = {-4,0,-3};
	float B2[] = {0,4,5};

	float d = distanceToTriangle(A1,B1,B2,x1);
	float v1 = metaball(sqrt(d), 1.5); 

	B2[1] = -4;
	d = distanceToTriangle(A1,B1,B2,x1);
	float v2 = metaball(sqrt(d), 1.5); 

	return v1 + v2 - 0.2;
	*/

	/*
	float A1[] = {0,0,-5};
	float B1[] = {0,0, 5};
	float B2[] = {0,0,0};
	float v = 0;
	for(int i=0; i<5; i++){
		B2[0] = 15*cos(2*PI*i/5);
		B2[1] = 15*sin(2*PI*i/5);
		double d = distanceToTriangle(A1,B1,B2,x);
		//v = min(sqrt(d), v);
		v += metaball(sqrt(d), 5.5);
	}
	
	return v - 0.1;
	*/

	//return 10.0 - sqrt(x[0]*x[0] + x[1]*x[1] + x[2]*x[2]);

	//#include "sphere_plane.txt"
	//#include "syuriken.txt"
	//#include "2way_twist.txt"
	#include "model.txt"
	//#include "star.txt"
	//#include "block.txt"
	//#include "twist.txt"
	//#include "doraemonH.txt"
	//#include "sphere_tori.txt"
	//#include "cube_sphere.txt"
	//#include "5triangle.txt"

	/*
	return model(x);

	float f = model(x);
	float g[3];
	nabla(x, g);
	return f/sqrt(f*f + g[0]*g[0] + g[1]*g[1] + g[2]*g[2]);
	*/
	
	/*
	float x1 = x[0];
	float y1 = x[1];
	float z1 = x[2];

	double angle2 = 0.5*PI*y1/30.0f;
	
	float xt = x1*cos(angle2) + z1*sin(angle2);
	float yt = y1;
	float zt = -x1*sin(angle2) + z1*cos(angle2);
	
	return R_int(R_int(1.0 - fabs(xt)/10, 1.0 - fabs(yt)/10), 1.0 - fabs(zt)/10);
	*/
	
	/*
	float x1 = x[0];
	float y1 = x[1];
	float z1 = x[2];

	double d = sqrt(x1*x1 + y1*y1 + z1*z1);
	if(d == 0)
		return 0;
	double c = z1/d;
	if(c > 1.0)
		c = 1;
	else if(c < -1.0)
		c = -1;
	double angle2 = 3.0*asin(c);

	//double angle = 0.25*PI*y1/30.0f;
	
	//float xt = x1*cos(angle2) + z1*sin(angle2);
	//float yt = y1;
	//float zt = -x1*sin(angle2) + z1*cos(angle2);
	
	
	float xt = x1*cos(angle2) - y1*sin(angle2);
	float yt = x1*sin(angle2) + y1*cos(angle2);
	float zt = z1;

	float sphere = 1.0 - xt*xt/225 - yt*yt/225 - zt*zt/225;
	//float sphere = 255.0 - xt*xt - yt*yt - zt*zt;

	float cube = R_int(R_int(1.0 - fabs(xt)/12, 1.0 - fabs(yt)/12), 1.0 - fabs(zt)/12);
	//float cube = R_int(R_int(12 - fabs(xt), 12 - fabs(yt)), 12 - fabs(zt));


	return R_int(cube, -sphere);

	/*	
	float xt = x[0];
	float yt = x[1];
	float zt = x[2];

	float sphere = 1.0 - xt*xt/255 - yt*yt/255 - zt*zt/255;
	float cylinder2 = R_int(1.0 - zt*zt/100 - yt*yt/100, sphere);

	float cylinder = 1.0 - xt*xt/64 - yt*yt/64;

	return R_int(cylinder2, -cylinder);
	*/

	/*
	float x1 = x[0];
	float y1 = x[1];
	float z1 = x[2];

	double angle = 3.5*PI*y1/30.0f;
	float xt = x1*cos(angle) + z1*sin(angle);
	float yt = y1;
	float zt = -x1*sin(angle) + z1*cos(angle);

	float cube = R_int(R_int(1.0 - fabs(xt)/10, 1.0 - fabs(yt)/10), 1.0 - fabs(zt)/10);

	return cube;

	float cylinder = 1.0 - xt*xt/64 - yt*yt/64;
	//float cylinder2 = R_int(1.0 - xt*xt/64 - zt*zt/64, 1.0 - fabs(yt)/12);
	float cylinder2 = R_int(1.0 - zt*zt/64 - yt*yt/64, 1.0 - fabs(xt)/12);

	return R_int(R_uni(cube, cylinder2), -cylinder);
	*/
	
	/*
	float x1 = x[0];
	float y1 = x[1];
	float z1 = x[2];
	return 1.0 - x1*x1/100 - y1*y1/100 - z1*z1/100;
	*/

	/*
	float x1 = x[0];
	float y1 = x[1];
	float z1 = x[2];
	return 1.0 - x1*x1/255 - y1*y1/100 - z1*z1/100;
*/
	/*
	float cyl = 100 - x[0]*x[0] - x[1]*x[1];
	return R_int(R_int(cyl, x[2]), 15-x[2]);
	*/
	//return min(min(cyl, x[2]), 15-x[2]);

	/*
	float cen[] = {0,0,0};
	float t1 = hfTorusZ(x, cen, 15, 4);
	cen[2] = 4;
	float t2 = hfTorusZ(x, cen, 15, 2);

	return R_int(t1, -t2);
	*/
	
	/*
	float x1 = x[0];
	float y1 = x[1];
	float z1 = x[2];

	//float cylinder = 1.0 - x1*x1/100 - y1*y1/255;
	float sphere1 =  1.0 - x1*x1/255 - y1*y1/100 - z1*z1/100;
	return min(sphere1, z1);
	//return R_int(-cylinder, sphere1);
	*/
	/*
	float x2 = x[0];
	float y2 = x[1];
	float z2 = x[2];
	
	double angle = PI*x2/20.0f;
	float x1 = x2;
	float y1 = y2; //-y2*sin(angle) + z2*cos(angle);
	float z1 = z2; //y2*cos(angle) + z2*sin(angle);

	float sphere1 =  255 - x1*x1 - y1*y1 - z1*z1;
	float sphere2 =  2-fabs(z1);
	float sphere3 =  255 - x1*x1 - (y1+15)*(y1+15) - z1*z1;

	return R_int(R_int(sphere1, sphere2), -sphere3);
	*/
	/*
	float x2 = x[0]*1.5;
	float y2 = x[1]*1.5;
	float z2 = x[2]*1.5;
	
	double angle = PI*x2/20.0f;
	float x1 = x2;
	float y1 = -y2*sin(angle) + z2*cos(angle);
	float z1 = y2*cos(angle) + z2*sin(angle);

	float p1[] = {x1,y1,z1};

	float sphere =  255 - x1*x1 - y1*y1 - z1*z1;
	//float sphere = 1.0 - x1*x1/255 - y1*y1/255 - z1*z1/255;
	//float cyl = 25 - x1*x1 - y1*y1;
	float cen[] = {0,0,0};
	float p[3];
	p[0] = x1;
	p[1] = cos(PI/4)*y1 - sin(PI/4)*z1;
	p[2] = sin(PI/4)*y1 + cos(PI/4)*z1;
	float torus1 = hfTorusZ(p, cen, 15, 4);

	p[0] = x1;
	p[1] = cos(-PI/4)*y1 - sin(-PI/4)*z1;
	p[2] = sin(-PI/4)*y1 + cos(-PI/4)*z1;
	float torus2 = hfTorusZ(p, cen, 15, 4);

	//cen[0] = 5;
	//float torus3 = hfTorusX(p1, cen, 15, 2);
	//cen[0] = -5;
	//float torus4 = hfTorusX(p1, cen, 15, 2);

	float torusD = R_uni(torus1, torus2);
	//float torusU = R_uni(torus3, torus4);

	//return R_int(R_int(sphere, -torusD), -torusU);;
	return R_int(sphere, -torusD);
	//return torusD;
	
	/*
	float cyl = min(min(100 - x[2]*x[2] - (x[1])*(x[1]), 10 - x[0]), 10 + x[0]);

	float cen[] = {0,0,10};
	float tri = hfTorusY(x, cen, 5, 2);

	float cen2[] = {9,0,0};
	float top = hfTorusX(x, cen2, 9,2);

	float cen3[] = {-9,0,0};
	float bottom = hfTorusX(x, cen3, 9, 2);

	float inner = 64 - x[2]*x[2] - (x[1])*(x[1]);

	return R_int(R_uni(R_uni(R_uni(tri, cyl), top), bottom),-inner);
	

	/*
	float ell = 1.0f - x[0]*x[0]/255.0f - x[1]*x[1]/100.0f - x[2]*x[2]/64.0f;

	return ell;
	*/
	

	/*
	float cone = R_int(0.25 - x[0]*x[0] - x[1]*x[1], x[2]-3);
	float cone2 = (x[0]+18)*(x[0]+18)/144 - (x[2]-10)*(x[2]-10) - x[1]*x[1];

	return R_int(cone2, -x[0]+10);

	float cylinder = R_int(R_int(0.25 - x[1]*x[1] - (x[2]-10)*(x[2]-10), 18-x[0]), x[0]);
	float c[] = {0,0,11};
	float r = 4 - (x[2]-c[0])/5;
	float apple = r*r-(x[0]-c[0])*(x[0]-c[0])
					-(x[1]-c[1])*(x[1]-c[1])
					-(x[2]-c[2])*(x[2]-c[2])/4 
						-r*r + 2*r*sqrt((x[0]-c[0])*(x[0]-c[0])+(x[1]-c[1])*(x[1]-c[1]));
	return R_uni(apple, R_int(cone, -x[2]+10));


	return R_uni(R_uni(R_uni(apple, R_int(cone, -x[2]+10)), cylinder),R_int(cone2, -x[0]+10));
	

	/*************************** noisy solid ********************
	float x1 = x[0];
	float y1 = x[1];
	float z1 = x[2];

	float noise = 3.0*sin(0.5*x1)*sin(0.1*y1)*sin(0.3*z1);
	float cube = R_int(R_int(10 - fabs(x1), 10 - fabs(y1)), 10 - fabs(z1));
	//float sphere = 100 - x1*x1 - y1*y1 - z1*z1;

	return noise + cube;

	/************************************************************/

	/********************twisted block *************

	float x1 = x[0];
	float y1 = x[1];
	float z1 = x[2];

	//if(0 <= y1 && y1 <= 15){
		float tar = (y1+15.0f)/15.0f;
		x1 /= tar*tar;
		z1 /= tar*tar;
	//}

	double angle = 4*PI*y1/30.0f;
	float xt = x1*cos(angle) + z1*sin(angle);
	float yt = y1;
	float zt = -x1*sin(angle) + z1*cos(angle);

	float rect = R_int(R_int(3 - fabs(xt), 15 - fabs(yt)), 1 - fabs(zt));
	//float rect2 = 4 - xt*xt - (yt-5)*(yt-5)/4;
	float rect3 = 4 - xt*xt - (yt-5)*(yt-5)/4;

	x1 = x[0];
	y1 = x[1];
	z1 = x[2];
	//if(y1 > -10)
	tar = (y1+14)/10;
	x1 /= tar*tar;
	z1 /= tar*tar;
	
	float sphere = 5 - x1*x1 - (y1+10)*(y1+10) - z1*z1;
	
	float f1 = R_int(rect, -rect3);
	float f2 = sphere;

	return R_uni(f1, f2) + 100/(1+(f1/2)*(f1/2)+(f2/2)*(f2/2));

	/********************twisted block2 ************

	float x1 = x[0];
	float y1 = x[1];
	float z1 = x[2];

	//if(0 <= y1 && y1 <= 15){
		//float tar = (y1+15.0f)/15.0f;
		//x1 /= tar*tar;
		//z1 /= tar*tar;
	//}

	float tar = 0.002*y1*y1 + 0.5;
	x1 /= tar;
	z1 /= tar;

	double angle = 4*PI*y1/30.0f;
	float xt = x1*cos(angle) + z1*sin(angle);
	float yt = y1;
	float zt = -x1*sin(angle) + z1*cos(angle);

	float rect = R_int(R_int(2 - fabs(xt-5), 19 - fabs(yt)), 6 - fabs(zt));

	return rect;
	//float rect2 = 4 - xt*xt - (yt-5)*(yt-5)/4;
	//float rect3 = 4 - xt*xt - (yt-5)*(yt-5)/4;

	//x1 = x[0];
	//y1 = x[1];
	//z1 = x[2];
	//if(y1 > -10)
	//tar = (y1+14)/10;
	//x1 /= tar*tar;
	//z1 /= tar*tar;
	
	//float sphere = 5 - x1*x1 - (y1+10)*(y1+10) - z1*z1;
	
	//float f1 = R_int(rect, -rect3);
	//float f2 = sphere;

	//return R_uni(f1, f2) + 100/(1+(f1/2)*(f1/2)+(f2/2)*(f2/2));

	/*****************************/

	/**********************************
	float x1 = x[0];
	float y1 = x[2];
	float z1 = x[1];
/*
	//float third = 1 - (z1+12)*(z1+12)/25 - x1*x1/16 - 4*(y1-11)*(y1-11)/25;

	//return third;

	//float eye = 1 - (z1+7)*(z1+7)/25 - 4*x1*x1/25 - (y1-11)*(y1-11)/16;
	//return eye;

	float f1 = 1 - (z1+18)*(z1+18)/100 - (x1-1)*(x1-1)/100 - (y1+1)*(y1+1)/100;
	float f2 = -y1-4.5;
	//float s2 = 1 - (z1+22)*(z1+22)/200 - (x1-1)*(x1-1)/800 - (y1-6)*(y1-6)/200;
	//float s1 = 1 - (z1+12)*(z1+12)/25 -  (x1-1)*(x1-1)/16 - 4*(y1+6)*(y1+6)/25;
	float in = R_int(f1, f2) + 1/(1+(f1/1)*(f1/1)+(f2/1)*(f2/1));
	float mouse = min(in, -z1);
	//float mouse = s1;

	return mouse;

	return 300 - (z1-20)*(z1-20) - x1*x1 - y1*y1;
*/
  /*
	float x1 = x[0]-1.8;
	float y1 = x[2];
	float z1 = x[1];

	float cube = R_int(R_int(10 - fabs(x1), 10 - fabs(y1)), 10 - fabs(z1));

	float cylinder3 = R_int(49 - z1*z1 - x1*x1, 19 - fabs(y1));

	float cylinder = 36 - x1*x1 - y1*y1;
	float cylinder2 = 36 - y1*y1 - z1*z1;

	return R_int(R_int(-cylinder, R_uni(cylinder3, cube)), -cylinder2);
	*/
/*
	float x1 = x[0]-1.8;
	float y1 = x[2];
	float z1 = x[1];

	float cube = R_int(R_int(1 - fabs(x1)/10, 1 - fabs(y1)/10), 1 - fabs(z1)/10);

	float cylinder3 = R_int(1 - z1*z1/49 - x1*x1/49, 1 - fabs(y1)/19);

	float cylinder = 1 - x1*x1/36 - y1*y1/36;
	float cylinder2 = 1 - y1*y1/36 - z1*z1/36;

	return R_int(R_int(-cylinder, R_uni(cylinder3, cube)), -cylinder2);
*/
/*
	float x1 = x[0];
	float y1 = x[2];
	float z1 = x[1];

	float sphere = 16 - x1*x1 - y1*y1 - z1*z1;
	float sphereD = 18 - x1*x1 - y1*y1 - z1*z1;
	float cylinder = 4 - x1*x1 - y1*y1;

	float s = R_uni(sphere, R_int(cylinder, sphereD));

	float sphere2 = 16 - x1*x1 - (y1-10)*(y1-10) - z1*z1;
	float sphereD2 = 12 - x1*x1 - (y1-10)*(y1-10) - z1*z1;
	float cylinder2 = 4 - x1*x1 - (y1-10)*(y1-10);

	float s2 = R_int(sphere2, -R_int(cylinder2, -sphereD2));

	return R_uni(s, s2) + 10/(1+(s/20)*(s/20)+(s2/20)*(s2/20));

	
	float cube = R_int(R_int(10 - fabs(x1-1), 10 - fabs(y1)), 10 - fabs(z1-2));
	
	//return cube;

	float cylinder3 = R_int(49 - (z1-1)*(z1-1) - x1*x1, 18 - fabs(y1));
	//return cylinder3;
	
	//return R_uni(cube, cylinder3);

	float cylinder = 25 - x1*x1 - y1*y1;
	float cylinder2 = 16 - (y1-3)*(y1-3) - z1*z1;

	//return cylinder3;

	return R_int(R_int(-cylinder, R_uni(cylinder3, cube)), -cylinder2);
	
	
	/**************************************

	//return 100 - x[0]*x[0] - x[1]*x[1] - x[2]*x[2];

	//return - max(max(fabs(x[0]-5)-10, fabs(x[1])-10), fabs(x[2])-10);
*/
/*
	float a = PI/8;
	float x2 = cos(a)*x[0] - sin(a)*x[1];
	float y2 = sin(a)*x[0] + cos(a)*x[1];
	float z2 = x[2];

	float x1 = x2;
	float y1 = cos(a)*y2 - sin(a)*z2;
	float z1 = sin(a)*y2 + cos(a)*z2;
	float cube = - R_uni(R_uni(fabs(x1-5)-10, fabs(y1)-10), fabs(z1)-10);
	float tube = - R_uni(fabs(x1-5)-5, fabs(y1)-5);
	float sphere = 25 - (x1-12)*(x1-12) - y1*y1 - z1*z1;
	float sphere2 = 25 - (x1+2)*(x1+2) - y1*y1 - z1*z1;
	float sphere3 = 9 - (x1-5)*(x1-5) - (y1-10)*(y1-10) - (z1-10)*(z1-10);

	return R_int(R_int(R_uni(R_int(cube, -tube), sphere), -sphere2), -sphere3);
	*/

	/*********************************************
	float  slabx,slaby,slabz,block,body,cyl1,cyl2;
	float xt = x[0]/2;
	float yt = x[1]/2;
	float zt = x[2]/2;
	// block 
	slabx = R_int(xt+8.3, 7.7-xt);
	slaby = R_int(yt+8.5, 7.5-yt);
	slabz = R_int(zt+8.8, 7.2-zt);
	block = R_int(slabx,slaby);
	block = R_int(block, slabz);

	//cylinders
	cyl1 = 25. - xt*xt - yt*yt;
	cyl2 = 16. - xt*xt - zt*zt;

	block = R_int(block,-cyl1);
	block = R_int(block,-cyl2);
	return block;

	/***********Letter "H"*******************
	
	float x1[3];
	x1[0] = x[0]/3  - 6;
	x1[1] = x[1]/3  - 3;
	x1[2] = x[2]/3  - 1.5;

	float A1[] = {-0.5,-2.5,3.0};
	float B1[] = {-0.5,-6.3,3.0};
	float d = distanceToSegment(A1,B1,x1);
	float v1;
	//if(d <= 2.5)
		v1 = metaball(sqrt(d), 1.5); //exp(-distanceToSegment(A1,B1,x1));
	//else 
		//v1 = 0;

	float A2[] = {-4.0,-2.5,3.0};
	float B2[] = {-4.0,-6.3,3.0};
	d = distanceToSegment(A2,B2,x1);
	float v2;
	//if(d <= 2.5)
		v2 = metaball(sqrt(d), 1.5);
	//else v2 = 0;

	float A3[] = {-1.0,-4.4,3.0};
	float B3[] = {-3.5, -4.4, 3.0};
	d = distanceToSegment(A3,B3,x1);
	float v3;
	//if(d <= 2.5)
		v3 = metaball(sqrt(d), 1.5);
	//else v3 = 0;

	return v1 + v2 + v3  - 0.2;

	/***********Letter "i"*******************
	
	float x1[3];
	x1[0] = x[0] - 6;
	x1[1] = x[1] - 1;
	x1[2] = x[2] - 1.5;

	float A4[] = {-2.5,-3.5,3.0};
	float B4[] = {-2.5,-6.3,3.0};
	float d = distanceToSegment(A4,B4,x1);
	float v4;
	if(d <= 2.25)
		v4 = metaball(sqrt(d), 1.5); 
	else 
		v4 = 0;

	float A5[] = {-2.5,-1.0,3.0};
	//float B2[] = {-2.5,-2.5,3.0};
	//d = distanceToSegment(A2,B2,x1);
	d = (x1[0]-A5[0])*(x1[0]-A5[0]) + (x1[1]-A5[1])*(x1[1]-A5[1]) + (x1[2]-A5[2])*(x1[2]-A5[2]);
	float v5;
	if(d <= 2.25)
		v5 = metaball(sqrt(d), 1.5);
	else v5 = 0;

	//return v1 + v2 + v3 + v4 + v5 - 0.2;

	return v4 + v5 - 0.2;

	/************Letter "E"***************

	float x1[3];
	x1[0] = x[0]; ///3;
	x1[1] = x[1]; ///3 - 5;
	x1[2] = x[2]; ///3;

	float A1[] = {-0.5,-2.5,3.0};
	float B1[] = {-0.5,-6.3,3.0};
	float d = distanceToSegment(A1,B1,x1);
	float v1;
	if(d > 0)
		v1 = metaball(sqrt(d), 1.5); //exp(-distanceToSegment(A1,B1,x1));
	else 
		v1 = 0;

	float A2[] = {-1.0,-2.0,3.0};
	float B2[] = {-4, -2.0, 3.0};
	d = distanceToSegment(A2,B2,x1);
	float v2;
	if(d > 0)
		v2 = metaball(sqrt(d), 1.5);
	else v2 = 0;

	float A3[] = {-1.0,-6.8,3.0};
	float B3[] = {-4, -6.8, 3.0};
	d = distanceToSegment(A3,B3,x1);
	float v3;
	if(d > 0)
		v3 = metaball(sqrt(d), 1.5);
	else v3 = 0;

	float A4[] = {-1.0,-4.4,3.0};
	float B4[] = {-4, -4.4, 3.0};
	d = distanceToSegment(A4,B4,x1);
	float v4;
	if(d > 0)
		v4 = metaball(sqrt(d), 1.5);
	else v4 = 0;

	return v1 + v2 + v3 + v4 - 0.2;

	***********************************/
	//float c1[] = {3,1,6};
	//return hfSphere(x, c1, 3);
	//return R_int(hfEllCylZ(x, c1, 5, 5), 19 -  fabs(x[2]));

	//return R_int(R_int(7 - fabs(x[0]-5), 7 - fabs(x[1])), 7 - fabs(x[2]));

	/*
	float c1[] = {0,0,0};
	float s1 = hfSphere(x, c1, 10);

	return s1;

	float c2[] = {0,-5,0};
	float s2 = hfSphere(x, c2, 10);

	return R_int(s1, s2);

	//return R_int(49 - (x[2]-1)*(x[2]-1) - x[0]*x[0], );

	/****************dolphi with pike ********************
	float x0 = x[0];
	float y0 = x[1];
	float z0 = x[2];

	float scaleY, scaleX, scaleZ;

	if(x0 >= 0)
		scaleX = 1.0f;
	else
		scaleX = 2.0f; //(fabs(y0)-3)*(fabs(y0)-3)/9 +1;

	if(y0 >= 0)
		scaleY = -0.01*x0*x0 + 2.0f;
	else
		scaleY = 1.0f;

	scaleZ = -0.01f*x0*x0 + 2.0f;

	float xt = x0/scaleX;
	float yt = y0/scaleY;
	float zt = z0/scaleZ;

	float body = 1.0f - xt*xt/100 - yt*yt/9 - zt*zt/9;

	return body;

	/**********************************************

	float x1[3];

	x1[0] = x[0]/2;
	x1[1] = -x[1]/2;
	x1[2] = x[2]/2;
	
	//x1[0] = x[0]/3.0;
	//x1[1] = -x[1]/3.0+5;
	//x1[2] = x[2]/3.0;

	float xx = x1[0]; 
    float y = x1[1]; 
    float z = x1[2]; 

    // head 
	float head1Cent[] = {0, 4.5, 0}; 
    float head = hfEllipsoid(x1, head1Cent, 6, 5.5, 6); 

    // nose 
	float hana1Cent[] = {0, 6.5, 5.9}; 
    float hana = hfEllipsoid(x1, hana1Cent, 0.75, 0.75, 0.75); 

    // face 
	float xface1Cent[] = {0, 4.5, 0.3}; 
    float xface1 = hfEllipsoid(x1, xface1Cent, 6, 5.5, 6); 
    float xface2Cent[] = {0, 3.7, 0}; 
    float xface2 = hfEllCylZ(x1, xface2Cent, 4.7, 4.5); 
    float atama1 = R_int(xface1, xface2); 

    // mouth
    float xkuti1Cent[] = {0, 4.5, 6}; 
    float xkuti1 = hfEllipsoid(x1, xkuti1Cent, 4, 4, 4); 
    float xkuti2 = 4.5-y; 
    float xkuti = R_int(xkuti1, xkuti2); 

    // eyes 
    float eye1Cent[] = {0, 4.5, 0.4}; 
    float eye1 = hfEllipsoid(x1, eye1Cent, 6, 5.5, 6); 
	//float eye1 = R_int(z, hfEllipsoid(x1, eye1Cent, 7.0, 6.0, 6.5)); 
    float eye2Cent[] = {1.5, 7.5, 0}; 
    float eye2 = hfEllCylZ(x1, eye2Cent, 1.5, 1.4); 
    float eye3 = R_int(eye1, eye2); 

    float eye4Cent[] = {-1.5, 7.5, 0}; 
    float eye4 = hfEllCylZ(x1, eye4Cent, 1.5, 1.4); 
    float eye5= R_int(eye1, eye4); 

    float eye6Cent[] = {0.3, 7.5, 5.5}; 
    float eye6 = hfEllipsoid(x1, eye6Cent, 0.3, 0.3, 0.3); 
	//float eye6Cent[] = {1.0, 7.5, 5.5}; 
    //float eye6 = hfEllipsoid(x1, eye6Cent, 1.0, 1.0, 1.0); 
    float eye7 = R_int(eye3, -eye6); 

    float eye8Cent[] = {-0.3, 7.5, 5.5}; 
    float eye8 = hfEllipsoid(x1, eye8Cent, 0.3, 0.3, 0.3); 
    float eye9 = R_int(eye5, -eye8); 

    //head final 
    float atama = R_int(R_uni(eye9, R_uni(eye7, R_uni(atama1, R_uni(head, hana)))), -xkuti); 
	
	//return atama;		
	//right moustache 
    float rh=0.2; 
    float rhige1Cent[] = {2, -3, 4.5}; 
    float rhige1 = hfTorusZ(x1, rhige1Cent, 10, rh); 
    float rhige2Cent[] = {2, -3.8, 4.5}; 
    float rhige2 = hfTorusZ(x1, rhige2Cent, 10, rh); 
    float rhige3Cent[] = {2, -4.6, 4.5}; 
    float rhige3 = hfTorusZ(x1, rhige3Cent, 10, rh); 

    //left moustache 
    float xlhige1Cent[] = {-2, -3, 4.5}; 
    float xlhige1 = hfTorusZ(x1, xlhige1Cent, 10, rh); 
    float xlhige2Cent[] = {-2, -3.8, 4.5}; 
    float xlhige2 = hfTorusZ(x1, xlhige2Cent, 10, rh); 
    float xlhige3Cent[] = {-2, -4.6, 4.5}; 
    float xlhige3 = hfTorusZ(x1, xlhige3Cent, 10, rh); 

    float rhani = R_int((xx-0), (6.5-xx)); 
    float rhige = R_int(R_int(R_uni(R_uni(rhige1, rhige2), rhige3), rhani), y); 

    float xlhani = R_int((xx+6.5), (0-xx)); 
    float xlhige = R_int(R_int(R_uni(R_uni(xlhige1, xlhige2),xlhige3),xlhani), y); 
    float hige = R_uni(xlhige, rhige); 

	//return R_uni(atama, hige);

    //body 
    float body1Cent[] = {0, -2, 0}; 
    float body1 = hfEllipsoid(x1, body1Cent, 4.5, 6, 4.5); 
    float body5 = R_int(R_int(body1, (6.+y)),(1.-y)); 

    //neck 
    float cubiwaCent[] = {0, 0, 0}; 
    float cubiwa = hfTorusY(x1, cubiwaCent, 4, 0.5); 

    //bell 
    float suzuCent[] = {0, 0, 4.5}; 
    float suzu = hfSphere(x, suzuCent, 0.8); 
    float body6 = R_uni(body5, cubiwa); 

    //belly 
    float hara1Cent[] = {0, -2, 0.3}; 
    float hara1 = hfEllipsoid(x1, hara1Cent, 4.5, 6, 4.5); 

    float hara2Cent[] = {0, -3, 0}; 
    float hara2 = hfEllCylZ(x1, hara2Cent, 2.3, 2.3); 
    float hara3 = R_int(hara1, hara2); 

    float hara4Cent[] = {0, -3, 0}; 
    float hara4 = hfEllCylZ(x1, hara4Cent, 1.6, 1.6); 

    float hara5Cent[] = {0, -2, 0.6}; 
    float hara5 = hfEllipsoid(x1, hara5Cent, 4.5, 6, 4.5); 
    float hara6 = -3-y; 
    float body = R_uni(R_uni(R_uni(body6, R_int(R_int(hara4, hara6),hara5)), hara3), suzu); 
	
	//legs and feet 
    float xllegCent[] = {3, -7.5, 0}; 
    float xlleg = hfEllipsoid(x1, xllegCent, 3, 1.5, 4); 

    float xrlegCent[] = {-3, -7.5, 0}; 
    float xrleg = hfEllipsoid(x1, xrlegCent, 3, 1.5, 4); 

    float xlfootCent[] = {2, -6, 0}; 
    float xlfoot = hfEllipsoid(x1, xlfootCent, 1, 1, 2); 

    float xrfootCent[] = {-2, -6, 0}; 
    float xrfoot = hfEllipsoid(x1, xrfootCent, 1, 1, 2); 
    float ashi = R_uni(R_uni(xlleg, xlfoot), R_uni(xrleg, xrfoot)); 

    //hands
    float hand1Cent[] = {8, -2.5, 0}; 
    float hand1 = hfSphere(x1, hand1Cent, 1.41); 
    float hand2Cent[] = {-8, -2.5, 0}; 
    float hand2 = hfSphere(x1, hand2Cent, 1.41); 

    float ude2 = xx+8; 
    float ude3 = 8-xx; 
    float ude1Cent[] = {0, -21, 0}; 
    float ude1 = hfTorusZ(x1, ude1Cent, 20, 1); 
    float te2 = R_uni(R_uni(R_int(R_int(ude1, ude3), ude2), hand1), hand2); 

    //final assembly 
    float my_model = R_uni(R_uni(R_uni(R_uni(atama, body), ashi), te2), hige); 

	return my_model;
	/********************************************************

	int N = 11;

	float f;
	double a = 0;
	double r2 = 12;
	f = r2 - (x[0]-10*cos(a))*(x[0]-10*cos(a)) - (x[1]-10*sin(a))*(x[1]-10*sin(a)) - x[2]*x[2];
	for(int i=0; i<N-1; i++){
		//float w = a;
		a = 2*i*PI/(N-1);
		if(i < N/2+1)
			f = R_uni(f, r2 - (x[0]-10*cos(a))*(x[0]-10*cos(a)) - (x[1]-10*sin(a))*(x[1]-10*sin(a)) - x[2]*x[2]);
		else{
			float f2 = r2 - (x[0]-10*cos(a))*(x[0]-10*cos(a)) - (x[1]-10*sin(a))*(x[1]-10*sin(a)) - x[2]*x[2];
			f = R_uni(f, f2) + 20/(1+(f/2)*(f/2)+(f2/2)*(f2/2));
		}
	}
	return f;
	/************* star ***************

	float x1 = x[0];
	float y1 = x[1];
	float z1 = x[2];

	double d = sqrt(x1*x1+y1*y1);
	if(d == 0)
		return 0;
	double c = x1/d;
	if(c > 1.0)
		c = 1;
	else if(c < -1.0)
		c = -1;
	double angle = acos(c);
	if(y1 < 0)
		angle = -angle;
	double r = sin(5*angle);
	float cyl = (3*r + 9)*(3*r + 9) - x1*x1 - y1*y1;

	float s1 = 400 - x1*x1 - y1*y1 - (z1+16)*(z1+16);
	float s2 = 400 - x1*x1 - y1*y1 - (z1-16)*(z1-16);

	float disk = R_int(s1, s2);

	float cyl2 = (r + 3)*(r + 3) - x1*x1 - y1*y1;

	//return disk;

	return R_int(R_int(cyl, disk), -cyl2);
	/***************** konpei *****************
	float x1 = x[0];
	float y1 = x[1];
	float z1 = x[2];

	double d = sqrt(x1*x1+y1*y1);
	//if(d == 0)
		//return 0;
	double c = x1/d;
	if(c > 1.0)
		c = 1;
	else if(c < -1.0)
		c = -1;
	double angle = acos(c);
	if(d == 0)
		angle = 0;

	d = sqrt(x1*x1 + y1*y1 + z1*z1);
	if(d == 0)
		return 0;
	c = z1/d;
	if(c > 1.0)
		c = 1;
	else if(c < -1.0)
		c = -1;
	double angle2 = asin(c);

	double r = sin(6*angle2)*cos(6*angle);

	float cyl = 16 - x1*x1 - y1*y1;
	float wave = (3*r + 10)*(3*r + 10) - x1*x1 - y1*y1 - z1*z1;

	return R_int(wave, -cyl) - 500/(1+(wave/2)*(wave/2)+(cyl/2)*(cyl/2));
	*/
	/**************

	float x1 = x[0];
	float y1 = x[1];
	float z1 = x[2];

	float vertices[][3] = 
	{{0.525731, 0.381966, 0.850651}, 
	{-0.200811, 0.618034, 0.850651}, 
	{-0.649839, 0., 0.850651}, 
	{-0.200811, -0.618034, 0.850651}, 
	{0.525731, -0.381966, 0.850651}, 
	{0.850651, 0.618034, 0.200811}, 
	{-0.32492, 1., 0.200811}, 
	{-1.05146, 0., 0.200811}, 
	{-0.32492, -1., 0.200811}, 
	{0.850651, -0.618034, 0.200811}, 
	{0.32492, 1., -0.200811}, 
	{-0.850651, 0.618034, -0.200811}, 
	{-0.850651, -0.618034, -0.200811}, 
	{0.32492, -1., -0.200811}, 
	{1.05146, 0., -0.200811}, 
	{0.200811, 0.618034, -0.850651}, 
	{-0.525731, 0.381966, -0.850651}, 
	{-0.525731, -0.381966, -0.850651}, 
	{0.200811, -0.618034, -0.850651}, 
	{0.649839, 0., -0.850651}};

	int N = 20;

	float f = 0;
	for(int i=0; i<N; i++){
		double d2 = (x1 - 10*vertices[i][0])*(x1 - 10*vertices[i][0]) +
					(y1 - 10*vertices[i][1])*(y1 - 10*vertices[i][1]) +
					(z1 - 10*vertices[i][2])*(z1 - 10*vertices[i][2]);
		f += exp(-d2/20);
	}

	return f - 0.9;
	*/
}

float OurImplicitFunction::R_int(float f1, float f2)
{
	//return min(f1,f2);
	return f1+f2-sqrt(f1*f1+f2*f2);
}

float OurImplicitFunction::R_uni(float f1, float f2)
{
	//return max(f1,f2);
	return f1+f2+sqrt(f1*f1+f2*f2);
}

float OurImplicitFunction::hfEllipsoid(float x[], float cen[], float a, float b, float c)
{
	return 1.0 - ((x[0]-cen[0])/a)*((x[0]-cen[0])/a) 
		- ((x[1]-cen[1])/b)*((x[1]-cen[1])/b)
		- ((x[2]-cen[2])/c)*((x[2]-cen[2])/c);
}

float OurImplicitFunction::hfEllCylZ(float x[], float cen[], float a, float b)
{
	return 1 - ((x[0]-cen[0])/a)*((x[0]-cen[0])/a) 
		- ((x[1]-cen[1])/b)*((x[1]-cen[1])/b);
}

float OurImplicitFunction::hfTorusX(float x[], float cen[], float R, float r)
{
	return r*r-(x[0]-cen[0])*(x[0]-cen[0])
		-(x[1]-cen[1])*(x[1]-cen[1])
		-(x[2]-cen[2])*(x[2]-cen[2]) 
		-R*R + 2*R*sqrt((x[1]-cen[1])*(x[1]-cen[1])+(x[2]-cen[2])*(x[2]-cen[2]));
}

float OurImplicitFunction::hfTorusY(float x[], float cen[], float R, float r)
{
	return r*r-(x[0]-cen[0])*(x[0]-cen[0])
		-(x[1]-cen[1])*(x[1]-cen[1])
		-(x[2]-cen[2])*(x[2]-cen[2]) 
		-R*R + 2*R*sqrt((x[2]-cen[2])*(x[2]-cen[2])+(x[0]-cen[0])*(x[0]-cen[0]));
}

float OurImplicitFunction::hfTorusZ(float x[], float cen[], float R, float r)
{
	return r*r-(x[0]-cen[0])*(x[0]-cen[0])
		-(x[1]-cen[1])*(x[1]-cen[1])
		-(x[2]-cen[2])*(x[2]-cen[2]) 
		-R*R + 2*R*sqrt((x[0]-cen[0])*(x[0]-cen[0])+(x[1]-cen[1])*(x[1]-cen[1]));
}

float OurImplicitFunction::hfSphere(float x[], float cen[], float r)
{
	return r*r - (x[0]-cen[0])*(x[0]-cen[0])
		- (x[1]-cen[1])*(x[1]-cen[1]) 
		- (x[2]-cen[2])*(x[2]-cen[2]);
}

//Meno: Prof. Pasko's handout pp.8 in "Skelton Model"
inline float OurImplicitFunction::distanceToSegment(float A[], float B[], float P[])
{
	float AC[3];

	double AB2 = (B[0]-A[0])*(B[0]-A[0]) + (B[1]-A[1])*(B[1]-A[1]) + (B[2]-A[2])*(B[2]-A[2]);
	double dot = (P[0]-A[0])*(B[0]-A[0]) + (P[1]-A[1])*(B[1]-A[1]) + (P[2]-A[2])*(B[2]-A[2]);
	
	AC[0] = (float)(dot*(B[0]-A[0])/AB2);
	AC[1] = (float)(dot*(B[1]-A[1])/AB2);
	AC[2] = (float)(dot*(B[2]-A[2])/AB2);

	double dot2 = AC[0]*(B[0]-A[0]) + AC[1]*(B[1]-A[1]) + AC[2]*(B[2]-A[2]);
	if(dot2 < 0)
		return (A[0]-P[0])*(A[0]-P[0]) + (A[1]-P[1])*(A[1]-P[1]) + (A[2]-P[2])*(A[2]-P[2]);
	else if(AB2 < AC[0]*AC[0]+AC[1]*AC[1]+AC[2]*AC[2])
		return (B[0]-P[0])*(B[0]-P[0]) + (B[1]-P[1])*(B[1]-P[1]) + (B[2]-P[2])*(B[2]-P[2]);
	else
		return (AC[0]+A[0]-P[0])*(AC[0]+A[0]-P[0]) + 
				(AC[1]+A[1]-P[1])*(AC[1]+A[1]-P[1]) + 
					(AC[2]+A[2]-P[2])*(AC[2]+A[2]-P[2]);
}

inline float OurImplicitFunction::metaball(float r, float d)
{
	if(r <= d/3.0f)
		return (1.0f-3.0f*r*r/(d*d));
	else if(r <= d)
		return 1.5f*(1.0f-r/d)*(1.0f-r/d);
	else 
		return 0;
}

void OurImplicitFunction::EvaluateDD(float x[], float dd[][3])
{
	float p[3];
	p[0] = x[0] + h;
	p[1] = x[1];
	p[2] = x[2];
	float xf[3];
	EvaluateGradient(p, xf);

	p[0] = x[0] - h;
	float xb[3];
	EvaluateGradient(p, xb);

	p[0] = x[0];
	p[1] = x[1] + h;
	float yf[3];
	EvaluateGradient(p, yf);

	p[1] = x[1] - h;
	float yb[3];
	EvaluateGradient(p, yb);

	p[1] = x[1];
	p[2] = x[2] + h;
	float zf[3];
	EvaluateGradient(p, zf);

	p[2] = x[2] - h;
	float zb[3];
	EvaluateGradient(p, zb);

	dd[0][0] = (xf[0] - xb[0])/(2.0f*h);
	dd[1][0] = dd[0][1] = (xf[1] - xb[1])/(2.0f*h);
	dd[2][0] = dd[0][2] = (xf[2] - xb[2])/(2.0f*h);
	dd[1][1] = (yf[1] - yb[1])/(2.0f*h);
	dd[1][2] = dd[2][1] = (yf[2] - yb[2])/(2.0f*h);
	dd[2][2] = (zf[2] - zf[2])/(2.0f*h);
}

float OurImplicitFunction::model(float x[])
{
	float x1 = x[0];
	float y1 = x[1];
	float z1 = x[2];

	double d = sqrt(x1*x1 + y1*y1 + z1*z1);
	if(d == 0)
		return 0;
	double c = z1/d;
	if(c > 1.0)
		c = 1;
	else if(c < -1.0)
		c = -1;
	double angle2 = asin(c);
	
	float xt = x1*cos(angle2) - y1*sin(angle2);
	float yt = x1*sin(angle2) + y1*cos(angle2);
	float zt = z1;

	//float sphere = 1.0 - xt*xt/255 - yt*yt/255 - zt*zt/255;
	float sphere = 255.0 - xt*xt - yt*yt - zt*zt;
	//return sphere;
	//float cube = R_int(R_int(1.0 - fabs(xt)/13, 1.0 - fabs(yt)/13), 1.0 - fabs(zt)/13);
	float cube = R_int(R_int(13 - fabs(xt), 13 - fabs(yt)), 13 - fabs(zt));


	return R_int(cube, -sphere);
}

void OurImplicitFunction::nabla(float x[], float g[])
{	
	float p1[3], p2[3];
	float H = h ;//sqrt(h);

	p1[0] = x[0] - H; 
	p1[1] = x[1];
	p1[2] = x[2];
	
	p2[0] = x[0] + H; 
	p2[1] = x[1];
	p2[2] = x[2];

	g[0] = (model(p2) - model(p1))/(2.0f*H);

	p1[0] = x[0]; 
	p1[1] = x[1] - H;
	p1[2] = x[2];
	
	p2[0] = x[0]; 
	p2[1] = x[1] + H;
	p2[2] = x[2];

	g[1] = (model(p2) - model(p1))/(2.0f*H);

	p1[0] = x[0]; 
	p1[1] = x[1];
	p1[2] = x[2] - H;
	
	p2[0] = x[0]; 
	p2[1] = x[1];
	p2[2] = x[2] + H;

	g[2] = (model(p2) - model(p1))/(2.0f*H);
}

void OurImplicitFunction::doubleNabla(float x[], float dd[][3])
{
	float p[3];
	p[0] = x[0] + h;
	p[1] = x[1];
	p[2] = x[2];
	float xf[3];
	nabla(p, xf);

	p[0] = x[0] - h;
	float xb[3];
	nabla(p, xb);

	p[0] = x[0];
	p[1] = x[1] + h;
	float yf[3];
	nabla(p, yf);

	p[1] = x[1] - h;
	float yb[3];
	nabla(p, yb);

	p[1] = x[1];
	p[2] = x[2] + h;
	float zf[3];
	nabla(p, zf);

	p[2] = x[2] - h;
	float zb[3];
	nabla(p, zb);

	dd[0][0] = (xf[0] - xb[0])/(2.0f*h);
	dd[1][0] = dd[0][1] = (xf[1] - xb[1])/(2.0f*h);
	dd[2][0] = dd[0][2] = (xf[2] - xb[2])/(2.0f*h);
	dd[1][1] = (yf[1] - yb[1])/(2.0f*h);
	dd[1][2] = dd[2][1] = (yf[2] - yb[2])/(2.0f*h);
	dd[2][2] = (zf[2] - zf[2])/(2.0f*h);
}

inline float OurImplicitFunction::distanceToTriangle(float A[], float B[], float C[], float P[])
{
	float AB[3], AC[3];
	MeshData::VEC(AB, A, B);
	MeshData::VEC(AC, A, C);
	double n[3];
	MeshData::CROSS(n, AB, AC);
	double len2 = n[0]*n[0] + n[1]*n[1] + n[2]*n[2];
	if((float)len2 != 0){
		float AP[3];
		MeshData::VEC(AP, A, P);
		double dot = MeshData::DOT(AP, n);
		double Q[3];
		Q[0] = P[0] - dot*n[0]/len2;
		Q[1] = P[1] - dot*n[1]/len2;
		Q[2] = P[2] - dot*n[2]/len2;

		double c[3], v[3];
		MeshData::CROSS(c, AB, n);
		MeshData::VEC(v, A, Q);
		if(MeshData::DOT(c, v) > 0){
			goto OUTER;
		}
		float BC[3];
		MeshData::VEC(BC, B, C);
		MeshData::CROSS(c, BC, n);
		MeshData::VEC(v, B, Q);
		if(MeshData::DOT(c, v) > 0){
			goto OUTER;
		}
		MeshData::CROSS(c, AC, n);
		MeshData::VEC(v, C, Q);
		if(MeshData::DOT(c, v) < 0){
			goto OUTER;
		}	
		return MeshData::DIST2(Q, P);
	}
	OUTER:
	double min = distanceToSegment(A, B, P);
	double d2 = distanceToSegment(B, C, P);
	if(d2 < min)
		min = d2;
	d2 = distanceToSegment(C, A, P);
	if(d2 < min)
		min = d2;
	return min;
}
