// PolyTestView.h : CPolyTestView NX̐錾уC^[tFCX̒`܂B
//
/////////////////////////////////////////////////////////////////////////////

#if !defined(AFX_POLYTESTVIEW_H__67E1C604_340B_4168_8A09_D373342D1898__INCLUDED_)
#define AFX_POLYTESTVIEW_H__67E1C604_340B_4168_8A09_D373342D1898__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include <gl\gl.h>
#include <gl\glu.h>
#include <math.h>

#include "VolumeFunction.h"

class CPolyTestView : public CView
{
protected: // VACY@\݂̂쐬܂B
	CPolyTestView();
	DECLARE_DYNCREATE(CPolyTestView)

// Agr[g
public:
	CPolyTestDoc* GetDocument();
	float v_err, f_err;
	int face_N, vertex_N;

// Iy[V
public:

// I[o[Ch
	// ClassWizard ͉z֐̃I[o[Ch𐶐܂B
	//{{AFX_VIRTUAL(CPolyTestView)
	public:
	virtual void OnDraw(CDC* pDC);  // ̃r[`悷ۂɃI[o[Ch܂B
	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
	protected:
	//}}AFX_VIRTUAL

// Cve[V
public:
	void drawSqrt3(MeshData* mesh);
	void drawCenterGraph(MeshData* mesh);
	void drawBoundBox();
	void drawFixedVertex(MeshData* mesh);
	void draw();
	void initGL();
	void wireFrame(MeshData *mesh);
	void flatShade(MeshData *mesh);
	virtual ~CPolyTestView();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:
	HGLRC m_hRC;
	GLdouble eye[3], center[3];
	GLfloat Rx,Ry,Rz;
	int px, py;
	float vx[3], vy[3], vz[3];
	BOOL isLPressed, isRPressed;
	float view_angle;
	float shift_x, shift_y, shift_z;

// ꂽbZ[W }bv֐
protected:
	//{{AFX_MSG(CPolyTestView)
	afx_msg void OnSize(UINT nType, int cx, int cy);
	afx_msg void OnDestroy();
	afx_msg int OnCreate(LPCREATESTRUCT lpCreateStruct);
	afx_msg void OnRButtonUp(UINT nFlags, CPoint point);
	afx_msg void OnRButtonDown(UINT nFlags, CPoint point);
	afx_msg void OnLButtonUp(UINT nFlags, CPoint point);
	afx_msg void OnLButtonDown(UINT nFlags, CPoint point);
	afx_msg void OnKeyDown(UINT nChar, UINT nRepCnt, UINT nFlags);
	afx_msg void OnMouseMove(UINT nFlags, CPoint point);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

#ifndef _DEBUG  // PolyTestView.cpp t@CfobO̎gp܂B
inline CPolyTestDoc* CPolyTestView::GetDocument()
   { return (CPolyTestDoc*)m_pDocument; }
#endif

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ ͑Os̒Oɒǉ̐錾}܂B

#endif // !defined(AFX_POLYTESTVIEW_H__67E1C604_340B_4168_8A09_D373342D1898__INCLUDED_)
